// koka generated module: "process"
if (typeof define !== 'function') { var define = require('amdefine')(module) }
define(['child_process', './std_core', './std_path', './std_dict'], function(child_process, $std_core, $std_path, $std_dict) {
"use strict";
 
// koka declarations:
/*---------------------------------------------------------------------------
  Copyright 2013-2015 Microsoft Corporation.
  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the file "license.txt" at the root of this distribution.
---------------------------------------------------------------------------*/
function system_exec(cmds, callback, timeout, cwd, env) {
   //js inline "child_process.exec(#1,{timeout:#3,cwd:(#4!=''?#4:undefined),env:(#5?(#5).unJust:undefined),windowsVerbatimArguments:true},function(err,stdout,stderr) { (#2)(err?err.code:0,stdout,stderr); });"
   // console.log("systemx exec: " + cmds);
   var options = {
     timeout: timeout,
     cwd: (cwd!=''?cwd:undefined),
     env: (env?(env).unJust:undefined),
     windowsVerbatimArguments: true,
   };
   var allout = "";
   var allerr = "";
   var lasterr = 0;
   var commands = cmds.split(";");
   var count = commands.length;
   var i;
   for(i = 0; i < count; i++) {
     var cmd = commands[i];
     // console.log(" exec: " + cmd);
     child_process.exec(cmd, options, function(err,stdout,stderr) {
       allout += stdout + "\n";
       allerr += stderr + "\n";
       if (err) lasterr = err.code;
       count--;
       if (count<=0) {
         (callback)( lasterr, allout, allerr);
       }
     });
   }
}
 
// quote file and command names for shell execution
function quote(s)  /* (s : string) -> string */  {
  return ("\"" + (s + "\""));
}
function systemx(cmd, callback, timeout, cwd, env)  /* forall<e> (cmd : string, callback : (int, string, string) -> <io|e> (), timeout : ?int, cwd : ?string, env : ?maybe<std/dict/dict<string>>) -> <io|e> () */  {
  var timeout_94 = (timeout !== undefined) ? timeout : 0;
  var cwd_98 = (cwd !== undefined) ? cwd : "";
  var env_103 = (env !== undefined) ? env : $std_core.Nothing;
  return system_exec(cmd,callback,timeout_94,cwd_98,env_103);
}
function system(cmd, callback, timeout, cwd, env)  /* forall<e> (cmd : string, callback : (int, string, string) -> <io|e> (), timeout : ?int, cwd : ?string, env : ?list<(string, string)>) -> <io|e> () */  {
  var timeout_120 = (timeout !== undefined) ? timeout : 0;
  var cwd_124 = (cwd !== undefined) ? cwd : "";
  var env_129 = (env !== undefined) ? env : $std_core.Nil;
  if ($std_core.isNil(env_129)) {
    var _x0 = $std_core.Nothing;
  }
  else {
    var _x0 = $std_core.Just($std_dict.dict_1(env_129));
  }
  return systemx(cmd, callback, timeout_120, cwd_124, _x0);
}
 
// koka exports:
return { 'quote': quote, 'systemx': systemx, 'system': system };
});